VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DirectMusic Player"
   ClientHeight    =   3045
   ClientLeft      =   5160
   ClientTop       =   3165
   ClientWidth     =   4830
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   203
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   322
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Caption         =   "Music Options"
      Enabled         =   0   'False
      Height          =   1155
      Left            =   120
      TabIndex        =   4
      Top             =   1740
      Width           =   4575
      Begin VB.HScrollBar scrlTempo 
         Height          =   135
         LargeChange     =   10
         Left            =   120
         Max             =   200
         Min             =   25
         TabIndex        =   8
         Top             =   900
         Value           =   100
         Width           =   4335
      End
      Begin VB.HScrollBar scrlVolume 
         Height          =   135
         LargeChange     =   10
         Left            =   120
         Max             =   100
         TabIndex        =   6
         Top             =   480
         Value           =   75
         Width           =   4335
      End
      Begin VB.Label lblmisc 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Tempo:"
         Height          =   195
         Index           =   1
         Left            =   120
         TabIndex        =   7
         Top             =   660
         Width           =   540
      End
      Begin VB.Label lblmisc 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Volume:"
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   570
      End
   End
   Begin VB.CommandButton CmdStep4 
      Caption         =   "4. Stop Playing"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   1200
      Width           =   4575
   End
   Begin VB.CommandButton cmdStep3 
      Caption         =   "3. Start Playing"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   4575
   End
   Begin VB.CommandButton cmdStep2 
      Caption         =   "2. Load Music"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   4575
   End
   Begin VB.CommandButton cmdStep1 
      Caption         =   "1. Initialise Everything"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4575
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'''''''We need a root object:
Dim dx As New DirectX7

'A performance controls the music. It looks after
'sending data to the music port, setting options
'converting time sigs. etc...
Dim perf As DirectMusicPerformance
'A segment is where the actual data is stored;
'like a buffer or a surface in other DirectX objects
Dim seg As DirectMusicSegment
'This variable lets us know what the music is
'doing. At the simplest level this is "am I playing?"
'"am i stopped?" etc.......
Dim segstate As DirectMusicSegmentState
'A loader object is what parses the data from a file
'on the hard drive to the area in memory.
Dim loader As DirectMusicLoader





Sub SetTempo(nTempo As Single)
'the tempo must be between 0.25 and 2
'the default is 1; 2 would double this, 0.5 would half this
perf.SetMasterTempo nTempo
End Sub


Sub SetVolume(nVolume As Byte)
'This formula allows you to specify a volume between
'0-100; similiar to a percentage
perf.SetMasterVolume (nVolume * 42 - 3000)
End Sub


Private Sub cmdStep1_Click()
    On Error GoTo LocalErrors
    
    'Create our loader object. Used in cmdStep2
    Set loader = dx.DirectMusicLoaderCreate()

    'A performance is what organises the events
    'think of it as a conductor - syncronising things
    'setting things up; looking after the individual pieces
    'of music.
    
    'Create the performance
    Set perf = dx.DirectMusicPerformanceCreate()
    'initialise it
    Call perf.Init(Nothing, 0)
    
    'Set it's options - these options should be standard
    'across most projects.
    perf.SetPort -1, 80
    Call perf.SetMasterAutoDownload(True)
    'Set the volumes to their default values:
    Call SetVolume(scrlVolume.Value)
    Call SetTempo(scrlTempo / 100)
    
    'Just some UI stuff to stop
    'you doing things in the wrong order and screwing things
    'up..... ;)
    cmdStep1.Enabled = False
    cmdStep2.Enabled = True
    Frame1.Enabled = True

Exit Sub
LocalErrors:
End Sub

Private Sub cmdStep2_Click()
'A variable to hold our file name...
Dim FILENAME As String

On Error GoTo LocalErrors

'We'll just hope that this file exists. It's only a tutorial
'after all ;-)
FILENAME = "c:\windows\media\passport.mid"

'You could load a segment file here (.Sgt) you dont
'have to have MIDI

'Use the loader object to create us a music buffer
Set seg = loader.LoadSegment(FILENAME)

'Set the format of the segment to be a MIDI.
seg.SetStandardMidiFile

cmdStep2.Enabled = False
cmdStep3.Enabled = True
    
Exit Sub
LocalErrors:
MsgBox "There was an Error; music may not have been loaded correctly"
End Sub

Private Sub cmdStep3_Click()
        'This is all it takes to start playing.
        'The last variable states where to start playing from;
        'in this case "0", which means the beginning.
        Set segstate = perf.PlaySegment(seg, 0, 0)
        cmdStep3.Enabled = False
        CmdStep4.Enabled = True
End Sub

Private Sub CmdStep4_Click()
    Call perf.Stop(seg, segstate, 0, 0)
    CmdStep4.Enabled = False
    cmdStep3.Enabled = True
End Sub



Private Sub Form_Unload(Cancel As Integer)
    If Not (perf Is Nothing) Then perf.CloseDown
End Sub





























Private Sub scrlTempo_Change()
'The only reason that this has the /100
'in it is because the scrollbar wont accept decimal places
'The normal range is 0.25 to 2.00 (*100 means no decimal places)
SetTempo scrlTempo.Value / 100
'Just some info
lblmisc(1).Caption = "Tempo: " & Format$(scrlTempo.Value / 100, "0.00") & "x"
End Sub


Private Sub scrlVolume_Change()
SetVolume scrlVolume.Value
End Sub


